﻿Imports System.Configuration
Imports System.IO
Imports System.Data.SqlServerCe
Imports Infragistics.Olap.FlatData

Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim conString As String = "Data Source= " + Application.StartupPath + "\..\..\Database1.sdf;"


        Using con As New SqlCeConnection(conString)

            Using cmd As New SqlCeCommand
                con.Open()
                cmd.Connection = con
                cmd.CommandText = "SELECT * FROM SportsData"
                Dim reader = cmd.ExecuteReader()

                Dim data As IEnumerable(Of SportsData) = CreateIEnumerable(reader)
                Dim ds As FlatDataSource = InitializePivotData(data)

                Dim parameters = New CubeGenerationParameters()
                ds.GenerateCube(parameters)
                ds.InitializeAsync(UltraPivotGrid1)

                UltraPivotGrid1.DataSource = ds
                OlapDataSelector1.DataSource = ds
            End Using

        End Using

    End Sub

    Private Function CreateIEnumerable(reader As SqlCeDataReader) As IEnumerable(Of SportsData)
        Dim listOfSportsData = reader.Cast(Of IDataRecord).
            Select(Function(s) New SportsData(s.Item(1), s.Item(2), s.Item(3), s.Item(4), s.Item(5)))
        Return listOfSportsData
    End Function

    Private Function InitializePivotData(data As IEnumerable(Of SportsData)) As FlatDataSource
        Dim itemSource As IEnumerable(Of SportsData) = data
        Dim settings = New FlatDataSourceInitialSettings()
        Dim ds = New FlatDataSource(itemSource.ToList(), GetType(SportsData), settings)

        AddHandler ds.InitializeHierarchyDescriptor, AddressOf ds_InitializeHierarchyDescriptor
        AddHandler ds.InitializeMeasureDescriptor, AddressOf ds_InitializeMeasureDescriptor
        AddHandler ds.AggregateMeasure, AddressOf ds_AggregateMeasure

        settings.Rows = "[SportsData].[Nation]"
        settings.Columns = "[SportsData].[Sport]"
        settings.Measures = "[Measures].[Budget]"

        Return ds
    End Function

    Private Sub ds_InitializeHierarchyDescriptor(sender As Object, e As InitializeHierarchyDescriptorEventArgs)
        Dim level As LevelDescriptor = e.HierarchyDescriptor.LevelDescriptors.ToList().FirstOrDefault(Function(lvl) lvl.Name = "all")

        If level IsNot Nothing Then
            Select Case e.HierarchyDescriptor.PropertyDescriptor.Name
                Case "Nation"
                    level.MemberProvider = Function(item) "All Nations"
                    Exit Select
                Case "City"
                    level.MemberProvider = Function(item) "All Cities"
                    Exit Select
                Case "Sport"
                    level.MemberProvider = Function(item) "All Sports"
                    Exit Select
            End Select
        End If

    End Sub

    Private Sub ds_InitializeMeasureDescriptor(sender As Object, e As InitializeMeasureDescriptorEventArgs)
        If (e.MeasureDescriptor.Name = "Budget") Then
            e.MeasureDescriptor.DisplayFormat = "$#"
            e.MeasureDescriptor.Aggregation = MeasureAggregation.Sum
        End If
    End Sub

    Private Sub ds_AggregateMeasure(sender As Object, e As AggregateMeasureEventArgs)
        If e.MeasureDescriptor.Name = "Budget" Then
            Dim total As Double = 0.0F
            Dim count As Double = 0.0F
            For Each o As Object In e.Items
                Dim item = TryCast(o, SportsData)
                If item IsNot Nothing Then
                    total += item.Budget
                End If
                count += 1.0F
            Next
            e.Value = total / count
            e.Handled = True
        End If

    End Sub



End Class
